%%% start with a clean memory
clear all
close all

%%% Define the problem A*x=b

for j=0:2
  [A,b,typeMV]=problem0(100,j);
  n=size(b,1);


fprintf('\n----------\nUse %s.\n\n',typeMV)
%%% str formats the output, displaying:
%%% the solution method, the dimension of the problem,
%%% required number of Matrix-vector multiplications, required solution time, 
%%% norm of the true residual, i.e., b-A*x with x the computed solution
%%% (norm of the residual as computed by the method)
str='%s\ndimension problem: %d\n#MVs: %d\ntime: %g\ntrue residual accuracy: %8.3g (%8.3g)\n\n';

%%% Solve using Polynomial solvers
%%% Local Minimal Residuals
[x,hist,t,NoMV]=polynomialsolver(A,b,0*b,1.0e-8,1000);
%%% display convergence history
figure
plot(0:length(hist)-1,log10(hist),'r-'), hold on
fprintf(str,'LMR ',n,NoMV,t,norm(b-feval(A,x),2),hist(end));


%%% Solve using a minimal residual solver
%%% GCR
[x,hist,t,NoMV]=gcr(A,b,0*b,1.0e-8,100);
plot(0:length(hist)-1,log10(hist),'k-*')
fprintf(str,'GCR ',n,NoMV,t,norm(b-feval(A,x),2),hist(end));


legend('LMR','GCR')


title(sprintf('Convergence history linear solvers. A is %d x %d',n,n))
xlabel('# MV')
ylabel('log_{10}||r_k||_2')

end
