function [MV,b,MyLAMBDA]=problem1(n)
%[MV,b]=problem1(n) 
%   defines the function that performes the multiplication with the matrix A,
%   i.e., the matrix-vector multiplication.
%   MV is the handle of this function.
%   n is a parameter that determines the dimension of A.
%   b is the right-hand side vector of the linear problem A*x=b.
%
%Note that size(b,1) will reveal the dimension of the problem.
%
%[MV,b,Lambda]=problem1(n)
%   Lambda is an size(b,1) x 1 array of eigenvalues of A
%
%Note: a function-handle is used to avoid repeatedly defining the matrix A.
%   See MATLAB's documentation "Using Handles to Store Function Parameters".
%

% A is a diagonal matrix

  %%% Define quantities that are required to define the matrix A
  Lambda=[1,100];
  h=(Lambda(2)-Lambda(1))/(n-1); 
  
  MyLAMBDA=(Lambda(1):h:Lambda(2))';
  nu=0.5; MyLAMBDA=MyLAMBDA.^nu;
  
  %%% Define the matrix A (as a diagonal matrix)
  %%% Either a ful matrix
  % A=diag(MyLAMBDA);
  %%% or a sparse matrix
  A=spdiags(MyLAMBDA,0,n,n);


  %%% Define the matrix-vector multiplication
  function c=MyMV(u)
    %%% Define the vector c as the result of multiplying u by A.
    c=A*u;
    %%% 
    %%% The action of the matrix need not be defined as an MV.
    %%% For instance, if the matrix is diagonal, then the action 
    %%% can also be defined as the coordinate wise product of 
    %%% u and the vector of diagonal entries:
    %%%
    % c=MyLAMBDA.*u; 
  end
  
  %%% return the handle for the MV:  
  MV=@MyMV;
  
  %%% Determine b.
  %%% In practise b is given. However, for testing purposes, it is convenient
  %%% to define b from a convenient solution x (which, of course, generally
  %%% is the quatity that has to be computed)
  
  x=ones(n,1);
  b=MyMV(x);

end