function [MV,b,MyLAMBDA]=problem2(n)
%[MV,b]=problem2(n) 
%   defines the function that performes the multiplication with the matrix A,
%   i.e., the matrix-vector multiplication.
%   MV is the handle of this function.
%   n is a parameter that determines the dimension of A.
%   b is the right-hand side vector of the linear problem A*x=b.
%
%[MV,b,Lambda]=problem2(n)
%   Lambda is an size(b,1) x 1 array of eigenvalues of A
%  
%
%  See also   problem1


% A is a rotation of a diagonal matrix: A=Q'*D*Q with D diagonal, Q unitary


  Lambda=[1,100];
  h=(Lambda(2)-Lambda(1))/(n-1); 

  MyLAMBDA=(Lambda(1):h:Lambda(2))';
  nu=0.5; MyLAMBDA=MyLAMBDA.^nu;

  D=spdiags(MyLAMBDA,0,n,n);
  
  %%% produce a random n x 3 orthonormal matrix V by
  %%% first producing an n x 3 random matrix
  V=rand(n,3);
  %%% then orthonormalise V
  >>> use qr to orthogonalise V
  
  function c=MyMV(u)
  
     >>> apply to u the Housholder reflection based on V
     c=D*u; 
     >>> apply to c the Householder reflection based on V
     
  end
  
  MV=@MyMV;
  
  x=ones(n,1);
  b=MyMV(x);

end