function [MV,b,Lambda]=problem3(n) 
%[MV,b]=problem3(n) 
%   defines the function that performes the multiplication with the matrix A,
%   i.e., the matrix-vector multiplication.
%   MV is the handle of this function.
%   n is a parameter that determines the dimension of A.
%   b is the right-hand side vector of the linear problem A*x=b.
%
%[MV,b,Lambda]=problem3(n)
%  Lambda is an size(b,1) x 1 array of eigenvalues of A
%  (returns Lambda=[] if n is too large to allow efficient computation).
%
%  
%  See also   problem1, problem0, problem0a

% A is an tri-diagonal matrix

   
   e = ones(n,1); d=2.01;
   A = spdiags([-e d*e -e], -1:1, n, n);
   
   function b=MyMV(x)
      b=A*x; 
   end
  
   MV=@MyMV;
  
   x=ones(n,1);
   b=MyMV(x);
  
   %%% Compute eigenvalues, if required and n is not too large
   if nargout>2
     Lambda=[];
     if n<2001, Lambda=eig(full(A)); end 
   end

end